/**
 * name: use-spotlight@1.0.4
 * desc: A react hook that generates 'spotlight' for active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
import { useState as k, useRef as I, useCallback as $, useEffect as z } from "react";
var j = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function A(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
var P = "Expected a function", L = 0 / 0, F = "[object Symbol]", D = /^\s+|\s+$/g, G = /^[-+]0x[0-9a-f]+$/i, V = /^0b[01]+$/i, H = /^0o[0-7]+$/i, U = parseInt, X = typeof j == "object" && j && j.Object === Object && j, q = typeof self == "object" && self && self.Object === Object && self, J = X || q || Function("return this")(), K = Object.prototype, Q = K.toString, Y = Math.max, Z = Math.min, C = function() {
  return J.Date.now();
};
function tt(t, r, e) {
  var n, a, c, f, s, l, u = 0, y = !1, d = !1, m = !0;
  if (typeof t != "function")
    throw new TypeError(P);
  r = B(r) || 0, O(e) && (y = !!e.leading, d = "maxWait" in e, c = d ? Y(B(e.maxWait) || 0, r) : c, m = "trailing" in e ? !!e.trailing : m);
  function i(o) {
    var p = n, S = a;
    return n = a = void 0, u = o, f = t.apply(S, p), f;
  }
  function v(o) {
    return u = o, s = setTimeout(h, r), y ? i(o) : f;
  }
  function g(o) {
    var p = o - l, S = o - u, E = r - p;
    return d ? Z(E, c - S) : E;
  }
  function T(o) {
    var p = o - l, S = o - u;
    return l === void 0 || p >= r || p < 0 || d && S >= c;
  }
  function h() {
    var o = C();
    if (T(o))
      return x(o);
    s = setTimeout(h, g(o));
  }
  function x(o) {
    return s = void 0, m && n ? i(o) : (n = a = void 0, f);
  }
  function b() {
    s !== void 0 && clearTimeout(s), u = 0, n = l = a = s = void 0;
  }
  function _() {
    return s === void 0 ? f : x(C());
  }
  function w() {
    var o = C(), p = T(o);
    if (n = arguments, a = this, l = o, p) {
      if (s === void 0)
        return v(l);
      if (d)
        return s = setTimeout(h, r), i(l);
    }
    return s === void 0 && (s = setTimeout(h, r)), f;
  }
  return w.cancel = b, w.flush = _, w;
}
function et(t, r, e) {
  var n = !0, a = !0;
  if (typeof t != "function")
    throw new TypeError(P);
  return O(e) && (n = "leading" in e ? !!e.leading : n, a = "trailing" in e ? !!e.trailing : a), tt(t, r, {
    leading: n,
    maxWait: r,
    trailing: a
  });
}
function O(t) {
  var r = typeof t;
  return !!t && (r == "object" || r == "function");
}
function rt(t) {
  return !!t && typeof t == "object";
}
function nt(t) {
  return typeof t == "symbol" || rt(t) && Q.call(t) == F;
}
function B(t) {
  if (typeof t == "number")
    return t;
  if (nt(t))
    return L;
  if (O(t)) {
    var r = typeof t.valueOf == "function" ? t.valueOf() : t;
    t = O(r) ? r + "" : r;
  }
  if (typeof t != "string")
    return t === 0 ? t : +t;
  t = t.replace(D, "");
  var e = V.test(t);
  return e || H.test(t) ? U(t.slice(2), e ? 2 : 8) : G.test(t) ? L : +t;
}
var it = et;
const ot = /* @__PURE__ */ A(it), st = {
  throttleWait: 0,
  enableBorderEdge: !1
}, W = [0, 0, 0, 0], R = { x: 0, y: 0, width: 0, height: 0 }, N = (t, r) => {
  var e;
  try {
    return +(((e = getComputedStyle(t, null)) == null ? void 0 : e.getPropertyValue(r)) ?? "").replace("px", "");
  } catch {
    return 0;
  }
}, M = (t, r) => {
  const e = (t == null ? void 0 : t.getBoundingClientRect()) ?? R, n = r ? N(t, "border-left-width") : 0, a = r ? N(t, "border-top-width") : 0;
  return {
    ...e,
    x: e.x - ((t == null ? void 0 : t.scrollLeft) ?? 0) + n,
    y: e.y - ((t == null ? void 0 : t.scrollTop) ?? 0) + a
  };
}, at = ([t, r, e, n]) => ({
  "--spotlight-x": `${t}px`,
  "--spotlight-y": `${r}px`,
  "--spotlight-w": `${e}px`,
  "--spotlight-h": `${n}px`,
  "--spotlight-duration": "200ms",
  "--spotlight-bg": "rgba(255, 0, 0, 0.1)",
  content: '""',
  display: "block",
  boxSizing: "border-box",
  position: "absolute",
  top: "0px",
  left: "0px",
  width: "var(--spotlight-w)",
  height: "var(--spotlight-h)",
  transform: "translate(var(--spotlight-x), var(--spotlight-y))",
  transitionProperty: "transform, width, height",
  transitionDuration: "var(--spotlight-duration)",
  background: "var(--spotlight-bg)",
  pointerEvents: "none"
}), ct = (t) => {
  const { throttleWait: r, enableBorderEdge: e } = { ...st, ...t }, [n, a] = k(W), [c, f] = k(R), [s, l] = k(R);
  let u = I(null), y = I(null);
  const d = $(
    (i) => {
      u.current = i, f(i ? M(i, e) : R);
    },
    [f, e]
  ), m = $(
    (i) => {
      y.current = i, l((i == null ? void 0 : i.getBoundingClientRect()) ?? R);
    },
    [l]
  );
  return z(() => {
    a([
      s.x - c.x,
      s.y - c.y,
      s.width,
      s.height
    ]);
  }, [c, s, a]), z(() => {
    const i = u.current, v = y.current;
    if (!i || !v)
      return () => a(W);
    let g = null;
    const T = ot(() => {
      const x = M(i, e), b = v.getBoundingClientRect();
      a([b.x - x.x, b.y - x.y, b.width, b.height]);
    }, r);
    typeof ResizeObserver < "u" && (g = new ResizeObserver(T), g.observe(i), g.observe(v));
    const h = i.style.position;
    return i.style.position = "relative", () => {
      i.style.position = h, g == null || g.disconnect();
    };
  }, [c, s, a, r, e]), {
    stage: d,
    actor: m,
    style: at(n),
    size: n
  };
}, ft = null;
export {
  ft as default,
  ct as useSpotlight
};
